#include "StdAfx.h"
#include "GameTalkAPIGlobal.h"
#include "WASProfileImage.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "ProfileImageActor.h"
#include "GameTalkAPIGlobal.h"
#include "GTCommonAPI.h"
#include "base64.h"
#include "UtilFunction.h"
#include <fcntl.h>


CWASProfileImage::CWASProfileImage(CWASActor *pActor) : CWASCommand(pActor), m_bCachedFile(false)
{
}


CWASProfileImage::~CWASProfileImage(void)
{
}


bool CWASProfileImage::RequestUploadImage()
{	
	USES_UTF8_CONVERSION;

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return false;
	}	
	
	return false;
//	DWORD dwFileSize = 0;
//	char * pData = NULL;
//	
//	if(m_sProfileImage.strFileName.length() > 0)
//	{
//#if defined(WIN32)  //__KEH_USE_PROFILE_IMAGE__
//		HBITMAP hBitmap = ImageUtil::LoadImage(m_sProfileImage.strFileName.c_str());
//		if(hBitmap == NULL)
//			return false;
//		DeleteObject(hBitmap);
//#endif	
//		
//		dwFileSize = CProfileImageActor::GetFileCRC(m_sProfileImage.strFileName.c_str(), &m_sProfileImage.dwCRC);
//		
//		pData = new char[dwFileSize];
//		if (NULL == pData)
//			return false;
//		
//#if defined(WIN32)  //__KEH_USE_PROFILE_IMAGE__
//		HANDLE hFile = CreateFile(m_sProfileImage.strFileName.c_str(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
//		if(hFile == INVALID_HANDLE_VALUE)
//		{
//			delete []pData;
//			return false;
//		}
//		
//		DWORD dwRead;
//		if(ReadFile(hFile, pData, dwFileSize, &dwRead, NULL) == FALSE)
//		{
//			CloseHandle(hFile);
//			delete []pData;
//			return false;
//		}
//		CloseHandle(hFile);
//#else
//		
//		int fd = open(W2U8(m_sProfileImage.strFileName.c_str()), O_RDONLY);
//		
//		if(-1 == fd)
//		{
//			delete []pData;
//			return false;
//		}
//		
//		char buf[2048];
//		DWORD dwTotalRead = 0;
//		DWORD dwRead;
//		while(dwTotalRead < dwFileSize)
//		{
//			dwRead = read(fd, buf, sizeof(buf));
//			
//			ASSERT(dwFileSize >= dwTotalRead + dwRead);
//			
//			memcpy(pData + dwTotalRead, buf, dwRead);
//			dwTotalRead += dwRead;
//		}
//		close(fd);
//		
//		if(dwTotalRead <= 0)
//		{
//			delete []pData;
//			return false;
//		}	
//#endif
//	}
//	else 
//	{
//		m_sProfileImage.dwCRC = 0;
//	}
//
//	
//	char szCRC[256];
//	WSTRING strURL = pMessengerActor->GetURL("SVR_MYPROFILEIMAGE", "OBJ_MYPROFILEIMAGE");
//
//	m_httpFacade.session().SetURL( W2U8(strURL.c_str()), pMessengerActor->GetMessengerTicket());
//	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);
//	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));
//	m_httpFacade.session().AddBodyVariable("action", "up");
//	sprintf(szCRC, "%08x", (unsigned int)m_sProfileImage.dwCRC);
//	m_httpFacade.session().AddBodyVariable("imgcrc", szCRC);
//	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());
//	m_httpFacade.session().AddBodyVariable("tickettype", pMessengerActor->GetMessengerTicketType());
//
//	if(m_sProfileImage.strFileName.length() > 0)
//	{
//		m_httpFacade.session().AddBodyFile("profileImage", W2U8(m_sProfileImage.strFileName.c_str()), "application/octet-stream", pData, dwFileSize);
//	}
//
//	m_httpFacade.session().SetKeepRawHeader(TRUE);
//	m_httpFacade.SendRequest(this, 60000);  // 60sec
//
//	if(pData)
//		delete []pData;
//
//	return true;
}


bool CWASProfileImage::RequestDownloadImage(void)
{
	char szTemp[256];
	USES_UTF8_CONVERSION;

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return false;
	}	

	WSTRING strURL = pMessengerActor->GetURL("SVR_MYPROFILEIMAGE", "OBJ_MYPROFILEIMAGE");

	m_httpFacade.session().SetURL( W2U8(strURL.c_str()), pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);
	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));		//  ̵ - Ƽ üũ ʿ
	m_httpFacade.session().AddBodyVariable("targetid", W2U8(m_sProfileImage.strUserID.c_str()));//  ̹  ϴ ̵
	m_httpFacade.session().AddBodyVariable("action", "down");

	sprintf(szTemp, "%d", (unsigned int)m_sProfileImage.eSizeType);
	m_httpFacade.session().AddBodyVariable("sizetype", szTemp);

	//  CRC WAS ȸϿ    
	// ̹  ̹ PC Ͽ  ִٴ ǹ̴!
	//  WAS ̹ ͸ ʴ´.

	sprintf(szTemp, "%08x", (unsigned int)m_sProfileImage.dwCRC);
	m_httpFacade.session().AddBodyVariable("imgcrc", szTemp);
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());

	m_httpFacade.session().SetKeepRawHeader(true);
	m_httpFacade.SendRequest(this, 0);  // no timeout..
	return true;
}


void CWASProfileImage::ExecuteAsync(void)
{
	bool bRet = false;
	if(m_bUploadFile)
		bRet = RequestUploadImage();
	else
		bRet = RequestDownloadImage();

}


bool CWASProfileImage::OnResponseUploadImage(const std::string &strHeader, bool &bSuccess)
{
	// Nothing to do..
	return true;
}


bool CWASProfileImage::OnResponseDownloadImage(const std::string &strHeader, bool &bSuccess)
{
	return false;
//	USES_UTF8_CONVERSION
//	DWORD dwCRC = 0;
//	int nPos = strHeader.find("profimg-crc: ");
//	if(nPos != -1)
//	{
//		const char *p = strHeader.c_str() + nPos + 12;
//		
//        ImageUtil::GetImageCRCFromString(p, dwCRC);
//	}
//
//	if(!bSuccess)
//	{
//		m_eError = wasError_Protocol;
//		return false;
//	}
//
//	if(m_bCachedFile)
//	{
//		do
//		{
//			if(GTCommonAPI::IsFileExist(W2U8(m_sProfileImage.strFileName.c_str())) == false)
//			{
//				break;
//			}
//
//			if(m_sProfileImage.dwCRC != dwCRC)
//			{
//				break;
//			}
//			return true;
//		}while(false);
//
//		bSuccess = false;
//		return false;
//	}
//
//	m_sProfileImage.dwCRC = dwCRC;
//
//	//bSuccess = true;
//
//	if(m_httpFacade.session().GetFileSize() <= 0)
//	{
//		m_eError = wasError_NotFound;
//		m_eProfileError = piError_NoImage;
//		return false;
//	}
//	
//	bool bOK = false;
//	char szFileName[MAX_PATH + 1];
//	if(GetFileNameFromHeader(m_httpFacade.session().GetRawHeader(), szFileName, sizeof(szFileName)) == false)		
//	{
//		m_eError = wasError_Protocol;
//		m_eProfileError = piError_WAS;
//		return false;
//	}
//
//    if(strlen(szFileName) <= 0)
//    {
//        m_sProfileImage.strFileName.clear();
//        m_sProfileImage.dwCRC = 0;
//        m_eError = wasError_None;
//        m_eProfileError = piError_NoImage;
//        return true;
//    }
//    
//    //---------------------------------------------
//    // m_sProfileImage.strFileName is target path!
//    //---------------------------------------------    
//    if(m_sProfileImage.strFileName.size() <= 0)
//    {
//        m_sProfileImage.strFileName = CProfileImageActor::GetProfileImageFilePath(m_sProfileImage.strUserID, U82W(szFileName));
//    }
//	
//    //printf(">> PROFILE IMAGE RECV SUCC : %s\n", W2U8(m_sProfileImage.strFileName.c_str()));
//    
//#if defined(WIN32)// __KEH_USE_PROFILE_IMAGE__		
//	HANDLE hFile = CreateFile(m_sProfileImage.strFileName.c_str(), GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
//	do
//	{
//		if(hFile == INVALID_HANDLE_VALUE)
//			break;
//
//		DWORD dwWritten;
//		if(WriteFile(hFile, m_httpFacade.session().GetFileData(), m_httpFacade.session().GetFileSize(), &dwWritten, NULL) == FALSE)
//			break;
//
//		bOK = true;
//	} while(false);
//
//	if(hFile != INVALID_HANDLE_VALUE)
//		CloseHandle(hFile);	
//#else
//	size_t ret = GTCommonAPI::WriteDataFile(W2U8(m_sProfileImage.strFileName.c_str()), 
//								   m_httpFacade.session().GetFileData(), 
//								   m_httpFacade.session().GetFileSize());
//	if(ret == m_httpFacade.session().GetFileSize())
//		bOK = true;
//#endif
//	// 
//	if(bOK)
//		m_eError = wasError_None;
//	else
//	{
//		m_eError = wasError_Internal;
//		m_eProfileError = piError_Disk;
//	}
//	return bSuccess;
}

bool CWASProfileImage::GetFileNameFromHeader(LPCSTR pszHeader, LPSTR pszFileName, size_t nSize)
{
	int i = 0;
	if(pszHeader == NULL)
		return false;

#define HEADER_FILE_NAME "profimg-name-base64: "
	const char * pszTemp = strstr(pszHeader, HEADER_FILE_NAME );
	if(pszTemp == NULL)
		return false;

	pszTemp += sizeof(HEADER_FILE_NAME) - 1;

	int nLen = strlen(pszTemp);
	for(i = 0; i < nLen; i++)
		if(pszTemp[i] == _T('\r') || pszTemp[i] == _T('\n'))
			break;

	if(i == 0)
    {
        if(nSize > 0)
            pszFileName[0] = '\0';
		return true;
    }

    strncpy(pszFileName, pszTemp, i);
	pszFileName[i] = 0;
	
	std::string strFileName = base64_decode(pszFileName);
	_snprintf(pszFileName, nSize - 1, "%s", strFileName.c_str());	
	
	return true;
}


bool CWASProfileImage::ParseAndEventFire(nfc::CIkXMLDom *pDom)
{
	bool bSuccess = false;

	//   ־Ѵ!
	if(m_httpFacade.session().GetRawHeader() != NULL)
	{
		std::string strHeader(m_httpFacade.session().GetRawHeader());

		m_bCachedFile = false;

		if(strHeader.find("resultcode: 100") != std::string::npos)
			bSuccess = true;
		else if(strHeader.find("profile-crc-diff: no") !=  std::string::npos)
		{
			bSuccess = true;
			m_bCachedFile = true;
		}

		if(m_bUploadFile)
		{
			bSuccess = OnResponseUploadImage(strHeader, bSuccess);
		}
		else
		{
			bSuccess = OnResponseDownloadImage(strHeader, bSuccess);
		}
	}
    
	return bSuccess;
}


// override in drived class

void CWASProfileImage::OnWasResponse(trid_t trid,
							   bool bSuccess,
							   int /*nWinINetErrorCode*/, 
							   int /*nHttpResponseCode*/, 
                               LPCSTR szWasResCodeInHeader, 
                               LPCSTR szWasResCodeInXml,
                               nfc::CIkXMLDom * pDom)
{
	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}

	GT_ASSERT(m_pActor);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t observers;
	m_pActor->GetObserversEx(&observers);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t::iterator it = observers.begin();

	GT_PROFILE_IMAGE_DATA sData;
	m_sProfileImage.Convert(sData);

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEventPrivate *pObserver = static_cast<IGTWASActorEventPrivate *>(*it);
		if(pObserver->OnGTWASActor_ResponseProfileImage(m_pActor, GetID(), m_eError, m_eProfileError, m_bUploadFile, sData, m_dwUserData1, m_dwUserData2) == false)
			break;
	}
	if(m_pActor)
		m_pActor->DeleteCommand(GetID());
}


void CWASProfileImage::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t observers;
	m_pActor->GetObserversEx(&observers);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t::iterator it = observers.begin();

	GT_PROFILE_IMAGE_DATA sData;
	m_sProfileImage.Convert(sData);

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEventPrivate *pObserver = static_cast<IGTWASActorEventPrivate *>(*it);
		if(pObserver->OnGTWASActor_ResponseProfileImage(m_pActor, GetID(), m_eError, m_eProfileError, m_bUploadFile, sData, m_dwUserData1, m_dwUserData2) == false)
			break;
	}
	if(m_pActor)
		m_pActor->DeleteCommand(GetID());
}
